{ZChess CheckMate Program}
uses GrAph,linux,crt, vgamouse;

{ below is the most important constant, maxdepth. Changing it may affect
  how the computer plays.

  4 = really poor play... and fast even on a 486.
  5 = not quite good... preferrable on a Pentium I, but if you have better, try 6.
  6 = moderate chess player, fast on a GHz+ processor
  7 = slow even on a modern comp, but really good
  8 and up... untested :)
  }

const       maxdepth : byte = 6;
	    mousestep = 6;
	    
	    { don't change these two: }
	    whoComp = 2;
	    whoPlayer = 1;
	    inf		= 1000000000;
	    MOVE_VALUE = 100;
	    { ListEl.t values: }
	    Capture = 5;
	    RegMove = 3;
	    PawnMove= 1;
	    WRAP_LOG = 57;


type TMap = array [0..47,0..47] of byte;
     TFigure = record
               t :  integer;  { 1=pawn; 2=knight; 3=bishop; 4=rook; 5=queen; 6=King }
               px : byte; { a,b,c,d,e,f,g,h }
               py : byte; { 1,2,3 ...       }
               end;
     TBoard  = array [1..8,1..8] of byte;
     RBoard  = array [0..7,1..8,1..8] of longint;
     Side    = array [1..16] of TFigure;
     CharsOfFigure = array [0..6] of char;
     FigValue = array [0..6] of longint;
     TMove    = record
                sx,sy,dx,dy : byte;
                end;
     ListEl   = record
                x,y : byte;
		t, v: byte;
                end;
     TrackArr = array [0..20] of TMove;
     ListArr  = array [1..32] of listel;
     BigList  = array [1..256] of listel;
     LenArr   = array [0..255] of integer;
     BranchArr= array [0..255] of longint;
     MSB       = array [0..9,0..14] of word;
     SidesStr  = array [0..3] of string[10];
     TState  = record
	       b      : TBoard;
	       wh,bl  : Side;
	       wc,bc  : byte;
    	       end;
     TGame   = array [1..200] of TState;	       	       


const figchr   : CharsOfFigure = (' ','p','n','b','R','Q','K');
      FigV     : FigValue      = (0, 100, 300, 310, 500, 950, 10000);
      
      { these control who plays white and who plays black }
      whowhite : integer = whoComp;
      whoblack : integer = whoPlayer;

      StartX   : longint = 127;
      StartY   : longint  =  47;
      redint   = 3.0;  {some color accention parameters          }
      greenint = 3.5;  {real values, max for all is 4.0          }
      blueint  = 4.0;  {3.0, 3.0, 4.0, will generate gray pallete}
                       {                with a slight blue accent}

      sDstr : SidesStr = ('','White','Black','');


var b                  : TBoard;
    wh,bl              : Side;
    wc,bc              : byte;
    wsq,bsq            : TMap;
    PW,PB              : pointer;
    FMap               : array [1..6] of TMap;
    RB                 : RBoard;
    GM		       : LenArr;
    GFX		       : BigList;
    GFC		       : integer;
    lmove              : TMove; { the last move                             }
    Hod		       : TGame;

    desiredfigure      : byte;  { this controls which figure will a pawn be }
                                { converted to due to respawn               }
    mouseemu		: boolean;
    meX, meY, meB	: integer;				
    mesc		: boolean;
    nodes, gennodes	: longint;
    tmsv		: extended;
    nspeed		: extended;
    currentmove		: integer;
    branch		: BranchArr;
    


function gray_to_16bit(x : byte) : longint; {converts 256-lvl grayscale color to 16bit rgb}
 begin
 gray_to_16bit := longint(x) shr 3 + (longint(x) shr 2) shl 5 + (longint(x) shr 3) shl 11;
 end;


function gtl : extended;
 var h,m,s,hds, mcs : word;
 begin
 gettime(h,m,s,hds, mcs);
 gtl := (h*3600.0 + m * 60.0 + s + hds/1000 + mcs/1000000);
 end;

(*
procedure CallMouse(service: word; var ax, bx, cx, dx, es: word);
var
	r: registers;
begin
	r.ax := service;
    r.bx := bx;
    r.cx := cx;
    r.dx := dx;
    r.es := es;
    intr($33, r);
    ax := r.ax;
    bx := r.bx;
    cx := r.cx;
    dx := r.dx;
    es := r.es;
end; {CallMouse}



function InitialiseMouse(var buttons: word): boolean;
var
	ax, a: word;
begin
	CallMouse(0, ax, buttons, a, a, a);
    InitialiseMouse := ax = $FFFF;
    xFactor := 1;
end; {InitialiseMouse}

procedure GetMousePosition(var x, y, button: word);
var
	a: word;
begin
	CallMouse(3, a, button, x, y, a);
    x := x div xFactor;
end; {GetMousePosition}


procedure MouseLimits(xMin, yMin, xMax, yMax: word);
var
	a: word;
begin
	xMin := xMin * xFactor;
    xMax := xMax * xFactor;
    CallMouse(7, a, a, xMin, xMax, a);
    CallMouse(8, a, a, yMin, yMax, a);
end; {MouseLimits}

*)

{---frontend to mouse unit---}
Procedure GetMousePosition(var x,y, button : word);
 var c : char;
 begin
 if not mouseemu then
 begin
 mouse_waitforupdate;
 x := mouse_getx;
 y := mouse_gety;
 button := mouse_getbutton; 
 if (x<0) or (x>=getmaxx) or (y<0) or (y>=getmaxy) then
    begin
    if x < 0 then x := 0;
    if x >= getmaxx then x := getmaxx;
    if y < 0 then y := 0;
    if y >= getmaxy then y := getmaxy;
    mouse_setposition(x,y);
    end;
 end else
    begin
    meB := 0;
    if keypressed then
	begin
	c := readkey;
	if c = #0 then
	    begin
	    c := readkey;
	    case ord(c) of
		72: MeY := MeY - mousestep;
		75: MeX := MeX - mousestep;
		77: MeX := MeX + mousestep;
		80: MeY := MeY + mousestep;
		end;
	    end
	 else
	    begin
	    if c = #27 then mesc := true;
	    if c = #32 then MeB := 1;
	    end;
	end;
    if mex < 0 then mex := 0;
    if mex >= getmaxx then mex := getmaxx;
    if mey < 0 then mey := 0;
    if mey >= getmaxy then mey := getmaxy;
    x := MeX;
    y := MeY;
    button := MeB;
    end;    
 end;

procedure status(S : String);
 var j : integer;
 begin
 setcolor(0);
 for j := 468 to 479 do line(540,j,639,j);
 setcolor(61309);
 line(540,468,639,468);
 line(540,468,540,479);
 line(639,468,639,479);
 line(540,479,639,479);
 setcolor(40147);
 outtextXY(542,470,s);
 end;


procedure log(S : String);
 var j : integer;
 begin
 setcolor(0);
 for j := 459 to 479 do line(40,j,500,j);
 setcolor(21162);
 if length(s) <= WRAP_LOG then
    begin
    rectangle(40,469,500,479);
    setcolor(40147);
    outtextXY(42,471,s);
    end else
    begin
    j := WRAP_LOG;
    while (s[j]<>' ') and (j>0) do dec(j); if j = 0 then j := WRAP_LOG;
    rectangle(40,459,500,479);
    setcolor(40147);
    OutTextXY(42,461,copy(s,1,j));
    OutTextXY(42,471,copy(s,j+1,255));
    end;
 end;


Procedure MessageBox(Caption,s : string);
 var i,l : integer;
     x1,y1,x2,y2 : integer;
     rc,capl,mxl,nxl : integer;
     s1 : string;
     c : char;
 begin
 capl := length(caption)*4;
 rc := 0;
 s:=s+'|';
 for i := 1 to length(s) do if s[i]='|' then inc(rc);
 y1 := 220-rc*6;
 y2 := 260+rc*6;
 mxl := 0;
 l:=0;
 for i := 1 to length(s) do if s[i]='|' then
  begin
  nxl := i-l-1;
  if nxl>mxl then mxl := nxl;
  l := i;
  end;
 x1:=300-mxl*4;
 x2:=340+mxl*4;
 SetFillStyle(SolidFill,1);
 Bar(x1,y1,x2,y2);
 setcolor(44373);
 rectangle(x1,y1,x2,y2);
 rectangle(x1+2,y1+2,x2-2,y2-2);
 bar(318-capl,y1-2,322+capl,y1+2);
 setcolor(29614);
 outtextXY(320-capl,y1-2,Caption);
 i := 0;
 setcolor(57083);
 while length(s)<>0 do
  begin
  s1:=copy(s,1,pos('|',s)-1);
  delete(s,1,pos('|',s));
  outtextxy(320-length(s1)*4,y1+20+i*12,s1);
  inc(i);
  end;
 repeat
 repeat until keypressed;
 c := readkey;
 until c in [#13,#32,#27]
 end;


Procedure Progress(x1,y1,x2,y2 : integer; p : real);
 var tx : integer;
 begin
 setcolor(40147);
 SetFillStyle(solidfill,8452);
 bar(x1,y1,x2,y2);
 rectangle(x1,y1,x2,y2);
 tx:= round((x2-x1-1)*p);
 setFillStyle(solidfill,21162);
 bar(x1+1,y1+1,x1+1+tx,y2-1);
 end;




procedure paste(x,y : integer; var a : TMap);
 var i,j : integer;
 begin
 for j := 0 to 47 do
  for i := 0 to 47 do putpixel(x+i,y+j,a[i,j]);
 end;

procedure PutFigBlack(x,y : integer; var a : TMap);
 var i,j : integer;
 begin
 for j := 0 to 47 do
  for i := 0 to 47 do if a[i,j]<>0 then putpixel(x+i,y+j,(a[i,j] shr 2) shl 5);
 end;

procedure PutFigWhite(x,y : integer; var a : TMap);
 var i,j : integer;
 begin
 for j := 0 to 47 do
  for i := 0 to 47 do if a[i,j]<>0 then putpixel(x+i,y+j,gray_to_16bit(round(a[i,j]*0.75+63)));
 end;

Procedure LoadXBackGround(fn : string);
 var buf : array [0..639] of byte;
     f : file of byte;
     i,j : integer;
 begin
 assign(f,fn);
 reset(F);
 for j := 0 to 479 do
  begin
  BlockRead(file(f), buf, 640);
  for i := 0 to 639 do putPixel(i,j,gray_to_16bit(buf[i]));
  end;
 close(f);
 end;


Procedure DisplayBoard(var B : TBoard);
 var i,j : integer;
 begin
 setcolor(44373);
 for i := 1 to 8 do OutTextXY(StartX+(i-1)*48+20,434,chr(64+i));
 for i := 1 to 8 do OutTextXY(514,469-(StartY+(i-1)*48+20),chr(48+i));
 for i := 1 to 8 do
  for j := 1 to 8 do if odd(i+j) then PutImage(StartX+(i-1)*48,StartY+(j-1)*48,Pb^,NormalPut)
                                 else PutImage(StartX+(i-1)*48,StartY+(j-1)*48,Pw^,NormalPut);
 for j := 1 to 8 do
  for i := 1 to 8 do if b[i,9-j]<>0 then
   begin
   if b[i,9-j]>64 then PutFigBlack(StartX+(i-1)*48,StartY+(j-1)*48,Fmap[b[i,9-j] mod 64])
                  else PutFigWhite(StartX+(i-1)*48,StartY+(j-1)*48,Fmap[b[i,9-j] mod 64]);
   end;
 setcolor(65535);
 rectangle(startx,starty,startx+384,starty+384);
 end;


Procedure OpenTMap(fn : string; var a : TMap);
 var f : file of byte;
     i,j : integer;
     b : byte;
 begin
 assign(f,fn);
 reset(f);
 for j := 0 to 47 do
  for i := 0 to 47 do
   begin
   read(f,b);
   a[i,j]:=b;
   end;
 close(f);
 end;


procedure DoTextures ; {some texture (TMap) initialisation}
 var i,j  : integer;
     s    : integer;
 begin
 for j := 0 to 47 do
  for i := 0 to 47 do
   begin
   wsq[i,j]:=13+random(3);
   bsq[i,j]:=random(3)+2;
   end;
 Paste(0,0,wsq);
 s := ImageSize(0,0,47,47);
 GetMem(Pw,s);
 GetImage(0,0,47,47,pw^);
 Paste(0,0,bsq);
 GetMem(Pb,s);
 GetImage(0,0,47,47,pb^);
 OutTextXY(260,220,'Reading bitmaps...');
 setcolor(65535);
 line(50,240,592,240);
 line(50,250,592,250);
 line(50,240,50,250);
 line(592,240,592,250);
 setcolor(40147);
 for i := 1 to 6 do
  begin
  OpenTMap('fig'+chr(i+48)+'.x',FMap[i]);
  for j := 241 to 249 do line(51+(i-1)*90,j,51+(i)*90,j);
  end;
 setcolor(29614);
 cleardevice;
 end;


procedure GraphInit;
 var gd,gm : integer;
 begin
 {linux:}
 gd := D16Bit; 
 gm := M640x480;
 initgraph(gd,gm,'');
 DoTextures;
 end;



function c2c(a : tmove): string;
 begin
 c2c := chr(96+a.sx)+chr(48+a.sy)+'-'+chr(96+a.dx)+chr(48+a.dy);
 end;

procedure swfig(var a,b : TFigure); inline;
 var c : TFigure;
 begin
 c:=a;
 a:=b;
 b:=c;
 end;


procedure readsave(fn : string);
 var s : string;
     t : text;
     i : byte;
 begin
 wc:=0; bc := 0;
 fillchar(b,sizeof(b),0);
 assign(t, fn);
 reset(t);
 for i := 1 to 6 do
  begin
  readln(t,s);
  while pos(' ',s)<>0 do delete(s,pos(' ',s),1);
  while s<>'' do
   begin
   inc(wc);
   wh[wc].t := i;
   wh[wc].px := ord(s[1])-96;
   wh[wc].py := ord(s[2])-48;
   b[wh[wc].px,wh[wc].py]:=i;
   delete(s,1,2);
   end;
  end;
 for i := 1 to 6 do
  begin
  readln(t,s);
  while pos(' ',s)<>0 do delete(s,pos(' ',s),1);
  while s<>'' do
   begin
   inc(bc);
   bl[bc].t := i;
   bl[bc].px := ord(s[1])-96;
   bl[bc].py := ord(s[2])-48;
   b[bl[bc].px,bl[bc].py]:=i+64;
   delete(s,1,2);
   end;
  end;

 close(t);
 end;


function ally (t : byte; sd : byte): boolean;
 var blf,bls : boolean;
 begin
 if t mod 64 =0 then
  begin
  ally := false;
  exit;
  end;
 blf := (t>64);
 bls := (sd=2);
 ally := not(blf xor bls);
 end;

function enemy (t : byte; sd : byte): boolean;
 var blf,bls : boolean;
 begin
 if t mod 64 =0 then
  begin
  enemy := false;
  exit;
  end;
 blf := (t>64);
 bls := (sd=2);
 enemy := (blf xor bls);
 end;


function getelsafe(x,y : byte): byte;
 begin
  if (x<1) or (x>8) or (y<1) or (y>8) then getelsafe :=0
                                      else getelsafe := b[x,y];
 end;

function empty (x,y : byte) : boolean;
 begin
 empty := false;
 if (x<1) or (x>8) or (y<1) or (y>8) then exit;
 if b[x,y]<>0 then exit;
 empty := true;
 end;



Procedure mkList(var L : ListArr; var LC : integer;var e: tfigure; index : byte; sd : byte);
 var mx,my : byte;

 function CheckP (x,y : longint) : longint; {0=ok; 1=encoutered enemy; 2=encountered ally; 3=other error}
  begin
  checkp := 3;
  if (x<1) or (x>8) or (y<1) or (y>8) then exit;
  if b[x,y]=0 then
   begin
   inc(lc);
   l[lc].x:=x; l[lc].y:=y;
   l[lc].v := index;
   if e.t <> 1 then l[lc].t := RegMove else
		    begin
                    l[lc].t := PawnMove;
		    if (y = 8) and (sd = 1) then l[lc].t := Capture; {queening}
		    if (y = 1) and (sd = 2) then l[lc].t := Capture; {queening}
		    end;
   inc(gm[l[lc].t]);
   inc(gfc);
   gfx[gfc] := l[lc];		    
   checkp := 0;
   exit;
   end;
{  if not ally(b[x,y],sd) then}
{ equivallent: }
   if (((sd-1) shl 6) xor (b[x,y] and 64)) > 0 then
   begin
   inc(lc);
   l[lc].x:=x; l[lc].y:=y;
   l[lc].t := Capture;
   l[lc].v := index;
   inc(gm[l[lc].t]);
   inc(gfc);
   gfx[gfc] := l[lc];		    
   checkp := 1;
   end else checkp := 2;
  end;

 procedure checkLine(sx,sy,xi,yi : longint);
  begin
  repeat
  sx:=sx+xi;
  sy:=sy+yi;
  until checkp(sx,sy)>0;
  end;


 begin
 lc :=0;
 mx := e.px;
 my := e.py;
 case e.t of
  1: {pawn}
     begin
     if sd=1 then
      begin
      if enemy(getelsafe(mx+1,my+1),sd) then checkp(mx+1,my+1);
      if enemy(getelsafe(mx-1,my+1),sd) then checkp(mx-1,my+1);
      if empty(mx,my+1) then checkp(mx,my+1);
      if my=2 then if empty(mx,my+1) and empty(mx,my+2) then checkp(mx,my+2);
      end
      else
      begin
      if enemy(getelsafe(mx+1,my-1),sd) then checkp(mx+1,my-1);
      if enemy(getelsafe(mx-1,my-1),sd) then checkp(mx-1,my-1);
      if empty(mx,my-1) then checkp(mx,my-1);
      if my=7 then if empty(mx,my-1) and empty(mx,my-2) then checkp(mx,my-2);
      end;
     end;
  2: {knight}
     begin
     checkp(mx+2,my+1);
     checkp(mx+2,my-1);
     checkp(mx-2,my+1);
     checkp(mx-2,my-1);
     checkp(mx+1,my+2);
     checkp(mx+1,my-2);
     checkp(mx-1,my+2);
     checkp(mx-1,my-2);
     end;
  3: {bishop}
     begin
     checkline(mx,my,-1,-1);
     checkline(mx,my,-1, 1);
     checkline(mx,my, 1,-1);
     checkline(mx,my, 1, 1);
     end;
  4: {rook}
     begin
     checkline(mx,my,-1, 0);
     checkline(mx,my, 1, 0);
     checkline(mx,my, 0,-1);
     checkline(mx,my, 0, 1);
     end;
  5: {queen}
     begin
     checkline(mx,my,-1,-1);
     checkline(mx,my,-1, 1);
     checkline(mx,my, 1,-1);
     checkline(mx,my, 1, 1);
     checkline(mx,my,-1, 0);
     checkline(mx,my, 1, 0);
     checkline(mx,my, 0,-1);
     checkline(mx,my, 0, 1);
     end;
  6: {king}
     begin
     checkp(mx-1,my);
     checkp(mx+1,my);
     checkp(mx-1,my-1);
     checkp(mx+1,my-1);
     checkp(mx,my-1);
     checkp(mx-1,my+1);
     checkp(mx+1,my+1);
     checkp(mx,my+1);
     end;
  end;
 end;


function chside(s : byte) : byte;
 begin
 if s = 2 then chside := 1 else chside := 2;
 end;

procedure removenode(var s : side; var c : byte; x,y : byte);
 var i,j : byte;
 begin
 for i := 1 to c do if (s[i].px=x) and (s[i].py=y) then
  begin
  dec(c);
  for j := i to c do s[j]:=s[j+1];
  fillchar(s[c+1],sizeof(s[c+1]),0);
  exit;
  end;
 end;

Procedure RemoveFigureAt(x,y : byte);
 var i,j : integer;
 begin
 for i := 1 to wc do if (wh[i].px=x) and (wh[i].py=y) then
  begin
  dec(wc);
  for j := i to wc do wh[j]:=wh[j+1];
  fillchar(wh[wc+1],sizeof(wh[wc+1]),0);
  exit;
  end;
 for i := 1 to bc do if (bl[i].px=x) and (bl[i].py=y) then
  begin
  dec(bc);
  for j := i to bc do bl[j]:=bl[j+1];
  fillchar(bl[bc+1],sizeof(bl[bc+1]),0);
  exit;
  end;
 end;
 
var best,tr : TrackArr;

procedure hemplog(max : real);
 var s,f : string;
 begin
 s:=c2c(best[maxdepth]);
 str(max:6:2,f);
 log('Variation: '+s+' ('+f+' points.)');
 end;

function eval(var ms,os : side; msc,osc : integer) : longint;
 var r : longint;
     i : integer;
 begin
 r := 0;
 for i := 1 to msc do
    inc(r, rb[ms[i].t, ms[i].px, ms[i].py]);
 for i := 1 to osc do
    dec(r, rb[os[i].t, os[i].px, os[i].py]); 
 eval := r;
 end;
 
procedure SortBigList(var a : BigList); inline;
 var X : LenArr;
     i : integer;
 begin
 x[Capture] := 0;
 x[RegMove] := gm[Capture];
 x[PawnMove] := gm[Capture] + gm[RegMove];
 for i := 1 to gfc do 
    begin
    inc(x[gfx[i].t]);
    a[x[gfx[i].t]] := gfx[i];
    end;
 end; 


function islastline(y,sd : byte) : boolean;
 begin
 if sd = 1 then islastline := (y=8)
           else islastline := (y=1);
 end;
 
function lmin(a,b : longint) : longint; inline;
 begin
 if a < b then lmin := a else lmin := b;
 end; 

function lmax(a,b : longint) : longint; inline;
 begin
 if a > b then lmax := a else lmax := b;
 end; 

function  bT(s : Side; sc : byte; os : side; oc : byte; sd : byte; ismax : boolean; lvl : byte; Aa, Bb : longint) : longint;
 var bs : TBoard;
     i,j : integer;
     l : ListArr;
     lc : integer;
     probe : longint;
     oss : side; ocs : byte;
     sx,sy,dx,dy : byte;
     ostouch : boolean;
     RSv : TFigure;
     Alpha, Beta : longint;
     FX : BigList;
     FC : integer;
 begin
 inc(nodes);
 if lvl=0 then
  begin
  if odd(maxdepth) then 
    bt := eval(os, s, oc, sc) - MOVE_VALUE
	else
    bt := eval(s, os, sc, oc) + MOVE_VALUE;
  exit;
  end;
 bs  :=    b;
 Alpha := -inf; Beta := +inf;
 oss := os; ocs := oc;
 gfc := 0; fc := 0;
 {fixme:}
 Gm[PawnMove] := 0;
 Gm[RegMove] := 0;
 Gm[Capture] := 0;
 for i := 1 to sc do 
    begin
    MkList(l, lc, s[i], i, sd);
    {for j := 1 to lc do fx[fc+j] := l[j];}
    inc(fc, lc);
    end;
 inc(gennodes, fc);    
 inc(branch[fc]);
 SortBigList(fx);
{ for i := 1 to sc do
  begin
  if lvl = maxdepth then Progress(5,64,45,72,(i-1)/sc);
  mklist (l,lc,s[i],i,sd);
  rsv := s[i];}
  for j := 1 to fc do
   begin
   ostouch := false;
   if lvl = maxdepth then Progress(5,64,45,72,(j-1)/fc);
   i := fx[j].v;
   rsv := s[i];
   sx:=s[i].px; sy:=s[i].py;
   dx:=fx[j].x; dy:=fx[j].y;
   tr[lvl].sx := sx;   tr[lvl].sy := sy;
   tr[lvl].dx := dx;   tr[lvl].dy := dy;

   if b[dx,dy]<>0 then
    begin
    ostouch := true;
    {mating check:}
    if (b[dx, dy] and 63) = 6 {king} then
	begin
	if ismax then bt := +10000
		 else bt := -10000;
	exit;
	end;
    removenode(os,oc,dx,dy);
    end;
   b[sx,sy]:=0;
   b[dx,dy]:=s[i].t;
   if (s[i].t = 1) and islastline(dy,sd) then
    begin
    s[i].t:=5;
    b[dx,dy]:=5;
    end;
   s[i].px:=dx; s[i].py:=dy;
   if sd=2 then inc(b[dx,dy],64);
   { ------------------------------------------------------------------- }
   { ------------------------------------------------------------------- }
   if ismax then
            probe := bt(os, oc, s, sc, (sd and 1) + 1, not ismax, lvl-1, lmax(alpha, aa), bb)
	    else
	    probe := bt(os, oc, s, sc, (sd and 1) + 1, not ismax, lvl-1, aa, lmin(beta, bb));
   { ----------- ^^^^ the actual recursive call is above ^^^ ----------- }
   { ------------------------------------------------------------------- }
   if ismax then 
	begin
	if probe > alpha then 
	    begin
	    alpha := probe;
	    if lvl=maxdepth then
    		begin
    		    best := tr;
    		    {}
    		    hempLog(alpha/100);
    		    {}
		end;
	    if alpha > bb then
		begin
		bt := alpha;
		b := bs;
		{}
		exit;
		end;
	    end;
	end else
	begin
	if probe < beta then 
	    begin
	    beta := probe;
	    if beta < aa then
		begin
		bt := beta;
		b := bs;
		{}
		exit;
		end;
	    end;
	end;
	
   if ostouch then
    begin
    os := oss;
    oc := ocs;
    end;
   b  := bs;
{   s  := ss;
   sc := scs;}
   s[i] := rsv;
   end;

 {b := bs;}
 if ismax then bt := alpha
	  else bt := beta;
 end;


Procedure ProceedMove(m : TMove;sd : byte);
 var SS : Side;
     i : integer;
     SC,e : byte;
 begin
 if empty(m.sx,m.sy) then
  {GenError('Illegal Move : '+c2c(m))};
 if not ally(b[m.sx,m.sy],sd) then
  {GenError('Illegal Move : '+c2c(m))};
 if sd = 1 then
  begin
  ss := wh; sc := wc;
  end
  else
  begin
  ss := bl; sc := bc;
  end;
 if not empty(m.dx,m.dy) then if enemy(b[m.dx,m.dy],sd) then
  RemoveFigureAt(m.dx,m.dy) else {GenError('Illegal Move (try to kill ally figure)')};
 for i := 1 to sc do if (ss[i].px=m.sx) and (ss[i].py=m.sy) then
  begin
  ss[i].px:=m.dx; ss[i].py:=m.dy;
  e:=b[m.sx,m.sy];
  b[m.sx,m.sy]:=0;
  if e and 63 = 1 then if islastline(m.dy,sd) then
   begin
   e:=e-1+desiredfigure;
   ss[i].t:=e and 63;
   end;
  b[m.dx,m.dy]:=e;
  if sd = 1 then
   begin
   wh := ss; wc := sc;
   end
   else
   begin
   bl := ss; bc := sc;
   end;
  exit;
  end;
 {GenError('Illegal Move : '+c2c(m));}
 end;
 
Procedure MkList_fe(var L : ListArr; var LC : byte;var e: tfigure;  sd : byte);
 var xx : integer;
 begin
 gfc := 0;
 fillchar(gm, sizeof(gm), 0);
 MKlist(l, xx, e, 0, sd);
 lc := xx;
 end;


Function  IsLegal( a : TMove; sd : byte; sm : boolean ) : boolean;
 var l : ListArr;
     lc : byte;
     i,j : byte;
     found : boolean;
     e:tfigure;
     bs,ws : side;
     wcs,bcs : byte;
     brd : TBoard;
     ms : side;
     mc,x,y : byte;
     inchess : boolean;

 begin
 IsLegal := false;
 if (a.sx<1) or (a.sx>8) or (a.sy<1) or (a.sy>8) or (a.dx<1) or (a.dx>8) or (a.dy<1) or (a.dy>8) then
  begin
  If sm then MessageBox('Error','Out Of Table');
  exit;
  end;
 if empty(a.sx,a.sy) then
  begin
  if sm then MessageBox('Error','Illegal Move');
  exit;
  end;
 if not ally(b[a.sx,a.sy],sd) then
  begin
  if sm then MessageBox('Error','Don''t touch my figures, bastard!');
  exit;
  end;
 if not empty(a.dx,a.dy) then if ally(b[a.dx,a.dy],sd) then
  begin
  if sm then MessageBox('Error','You can''t kill your friends.');
  exit;
  end;
 found := false;
 for i := 1 to wc do if (wh[i].px=a.sx) and (wh[i].py=a.sy) then
  begin
  found := true;
  e := wh[i];
  end;
 if not found then
 for i := 1 to bc do if (bl[i].px=a.sx) and (bl[i].py=a.sy) then
  begin
  found := true;
  e := bl[i];
  end;
 mklist_fe(l,lc,e,sd);
 found := false;
 for i:=1 to lc do if (l[i].x=a.dx)  and (l[i].y=a.dy) then found := true;
 if not found then
  begin
  if sm then MessageBox('Error','That figure cannot be moved there, fool!');
  exit;
  end;

 {save some parameters}
 bs := bl;
 bcs := bc;
 ws := wh;
 wcs := wc;
 brd := b;

 ProceedMove(a,sd);
 if sd=1 then
  begin
  ms := wh;
  mc := wc;
  end
  else
  begin
  ms := bl;
  mc := bc;
  end;

 for i := 1 to  mc do if ms[i].t=6 then
  begin
  x:=ms[i].px; y := ms[i].py;
  end;

 if sd=2 then
  begin
  ms := wh;
  mc := wc;
  end
  else
  begin
  ms := bl;
  mc := bc;
  end;

 inchess := false;

 for i := 1 to mc do
  begin
  mklist_fe(l,lc,ms[i],chside(sd));
  for j := 1 to lc do if (l[j].x=x) and (l[j].y=y) then inchess := true;
  end;

 if inchess then
  begin
  if sm then MessageBox('Error','Yo kin'' is in chess! haha :)');
  bl := bs;
  bc := bcs;
  wh := ws;
  wc := wcs;
  b := brd;
  exit;
  end;


 {restore the parameters}
 bl := bs;
 bc := bcs;
 wh := ws;
 wc := wcs;
 b := brd;
 IsLegal := true;
 end;




function  DoMove(sd : byte): boolean; {sd = 1 - move white, sd=2 - move black}
 var mv : TMove;
     r  : real;
 begin
 nodes := 0;
 gennodes := 0;
 fillchar(branch, sizeof(branch), 0);
 tmsv := gtl;
 domove := true;
 fillchar(best,sizeof(best),0);
 fillchar(tr,sizeof(tr),0);
{ if sd=1 then  r:=Bt(wh,wc,bl,bc,sd,maxdepth,0)
         else  r:=Bt(bl,bc,wh,wc,sd,maxdepth,0);}
 if sd = 1 then	 
    r := BT(wh, wc, bl, bc, sd, TRUE {max}, maxdepth, -inf, +inf)
    else
    r := BT(bl, bc, wh, wc, sd, TRUE {max}, maxdepth, -inf, +inf);
 nspeed := nodes / (gtl-tmsv+0.001);	 
 mv := best [maxdepth];
 lmove := mv;
 desiredfigure := 5; {computer will always respawn queen }
 if r < -500000 then
  begin
  MessageBox('Computer','I have no legal moves|Game Over');
  domove := false;
  exit;
  end;
 if not IsLegal(mv,sd,false) then
  begin
  MessageBox('Computer','I''m obviously losing this game|I surrender|Peace Brother!!!');
  domove:=false;
  exit;
  end;
 if r > 8000 then
  begin
  proceedmove(mv,sd);
  displayBoard(b);
  MessageBox('Computer',sdStr[chside(sd)]+' is mated|Game Over');
  repeat until keypressed;
  while keypressed do readkey;
  closegraph;
  halt(0);
  end;
 proceedmove(mv,sd);
 end;



procedure GetMSB(x,y : integer;var a : msb);
 var i,j : integer;
 begin
 for  i := 0 to 9 do
  for j := 0 to 14 do a[i,j]:=getPixel(x+i,y+j);
 end;

procedure putMSB(x,y : integer;var a: msb);
 var i,j : integer;
 begin
 for i := 0 to 9 do
  for j := 0 to 14 do putpixel(x+i,y+j,a[i,j]);
 end;

procedure drawmouse(x,y : integer);
 begin
 setcolor(0);
 line(x+1,y+1,x+1,y+14);
 line(x+2,y+1,x+9,y+8);
 line(x+1,y+14,x+9,y+9);
 setcolor(61309);
 line(x,y,x,y+13);
 line(x,y,x+8,y+8);
 line(x,y+13,x+8,y+8);

 end;

procedure BoldLine(sx,sy : integer; col : longint);
 var x1,y1,x2,y2 : integer;
 begin
 setcolor(col);
 x1:= startx + (sx-1)*48;
 y1:= starty + (8-sy)*48;
 x2:= x1+47;
 y2:= y1+47;
 rectangle(x1+1,y1+1,x2-1,y2-1);
 rectangle(x1,y1,x2,y2);
 rectangle(x1-1,y1-1,x2+1,y2+1);
 end;

procedure catchcoords(x,y : integer; var sx,sy : integer);
 begin
 sx:=(x-startx) div 48 + 1;
 sy:=(y-starty) div 48 + 1;
 sy:=9-sy;
 end;

Function askFigure : byte;
 var i           : integer;
     lx,ly,u,x,y : word;
     m : msb;
 begin
 LoadXBackGround('PawnFix.x');
 for i := 0 to 3 do putfigwhite(224+(i*48),216,fmap[i+2]);
 GetMousePosition(lx,ly,u);
 getmsb(lx,ly,m);
 repeat
 repeat
 GetMousePOsition(x,y,u);
 if (x<>lx) or (y<>ly) then
  begin
  putmsb(lx,ly,m);
  getmsb(x,y,m);
  drawmouse(x,y);
  lx:=x;
  ly:=y;
  end;
 until u<>0;
 until (x>224) and (x<416) and (y>216) and (y<264);
 askfigure:= (x-224) div 48 + 2;

 end;


Procedure Check_For_ReSpawN(V : TMove; sd : byte);
 { this one checks if a pawn has reached its last position }
 { also takes care if it is so                             }
 var e : byte;
 begin
 if b[v.sx,v.sy] and 63 <> 1 then exit;
 if not islastline(v.dy,sd) then exit;
 e:=AskFigure;
 DesireDFigurE := e;
 end;


function doUser(sd : integer) : boolean;
 var sx,sy,dx,dy : integer;
     lx,ly,u,x,y : word;
     sb          : MSB;
     seekdroppos : boolean;
     v : tmove;
     lastclick : extended;
     c : char;
     illMove : boolean;
     qx,qy : integer;
 begin
 sx := 0; sy := 0;
 lastclick := gtl;
 getmouseposition(lx,ly,u);
 getmsb(lx,ly,sb);
 seekDropPos := false;
 drawMouse(lx,ly);
 repeat
 getmousePosition(x,y,u);
 if mesc then
    begin
    douser := false;
    exit;
    end;
 if (x<>lx) or (y<>ly) then
  begin
  putmsb(lx,ly,sb);
  getmsb(x,y,sb);
  DrawMouse(x,y);
  end;
if (x>=startx) and (x<startx+384) and (y >=starty) and (Y< starty+384) then
 if gtl-lastclick>0.3 then if u <> 0 then
  begin
  illmove := false;
  lastclick:=gtl;
  if SeekDropPos then
   begin
   seekdropPos := false;
   catchcoords(x,y,dx,dy);
   v.sx:=sx; v.sy := sy; v.dx:=dx ;v.dy:=dy;
   if IsLegal(v,sd,true) then
    begin
    Check_for_respawn(v,sd);
    proceedmove(v,sd);
    douser := true;
    exit;
    end;
   illmove := true;
   displayboard(b);
   end;
  if not illmove then
   begin
   seekdroppos:=true;
   catchcoords(x,y,sx,sy);
   BoldLine(sx,sy,65535);
   end;
  end;
 lx := x; ly := y;
 if keypressed then
  begin
  c:= readkey;
  if ord(c)=27 then
   begin
   douser:= false;
   exit;
   end;
  if upcase(c)='Q' then
   begin
   repeat
   qx := random(8)+1;
   qy := random(8)+1;
   until empty(qx,qy);
   if sd = 1 then
    begin
    inc(wc);
    wh[wc].px:=qx;
    wh[wc].py:=qy;
    wh[wc].t := 5;
    b[qx,qy]:=5;
    end
    else
    begin
    inc(bc);
    bl[bc].px:=qx;
    bl[bc].py:=qy;
    bl[bc].t := 5;
    b[qx,qy]:=69;
    end;
   end;
  end;
 until false;
 end;
 
Function CalculateBranchFactor(var x : BranchArr) : real;
 var z, all : extended;
     i : integer;
 begin
 z := 0; all := 0;
 for i := 0 to 255 do 
    begin
    z := z + extended(i)*extended(x[i]);
    all := all + extended(x[i]);
    end;
 if all < 1 then CalculateBranchFactor := 0 else    
		 CalculateBranchFactor := z / all;    
 end;
 
Function Power(a : real; p : integer) : real;
 var x : real;
     i : integer;
 begin 
 x := 1;
 for i := 1 to p do x := x * a;
 Power := x;
 end; 
 
Function ExpNotation(x : real) : string;
 var s, suffix, prefix, av : string;
     i : integer;
 begin
 prefix := '';
 if x < 0 then prefix := '-';
 x := abs(x);
 if x < 1 then
    begin
    str(x:1:0,s);
    ExpNotation := prefix + s;
    exit;
    end;
 av := 'kMGTNNNNN';
 suffix := '';
 str(x:1:2, s);
 i := 1;
 while pos('.', s) > 4 do
    begin
    x := x / 1000;
    str(x:1:2, s);
    suffix := av[i];
    inc(i);
    end;
 if s[4]='.' then
    s := prefix + copy(s,1,3) + suffix        
	     else
    s := prefix + copy(s,1,4) + suffix;
 ExpNotation := s;
 end; 
 
Function CompStats : string;
 var s, s2 : string;
     ff : real;
 begin
 s := 'Last Move : '+c2c(lmove)+'; Nodes(all/done/gen)=';
{

    str(nspeed/1000:1:1,s);
    str(nodes/1000000:1:2, s2);
    log('Last Move : '+c2c(lmove)+'; '+s2+' MNode @ '+s+' Knodes/s');
}
 ff := CalculateBranchFactor(branch);
 s := s + ExpNotation(power(ff, maxdepth)) + '/';
 s := s + ExpNotation(nodes) + '/';
 s := s + ExpNotation(genNodes) + ' @ ' + ExpNotation(nspeed)+'nodes/s';
 str(ff:1:1, s2);
 s := s + '; branch='+s2;
 CompStats := s;
 end; 

Procedure SaveState(var z : TState);
 begin
 z.wh := wh;
 z.bl := bl;
 z.wc := wc;
 z.bc := bc;
 z.b := b;
 end;

procedure game;
 var she : boolean;
 begin
 currentmove := 1;
 she := false;
 repeat
 cleardevice;
 displayboard(b);
 savestate(hod[currentmove]);
 if whoWhite = WhoPlayer then
    begin
    log(CompStats);
    status('waiting');
    she := not (doUser(1));
    if she then break;
    end else
    begin
    status('thinking');
    DoMove(1);
    end;
 inc(currentmove);
 cleardevice;
 displayboard(b);
 savestate(hod[currentmove]);    
 if whoBlack = WhoPlayer then
    begin
    log(CompStats);
    status('waiting');
    she := not (doUser(2));
    if she then break;
    end else
    begin
    status('thinking');
    DoMove(2);
    end;
 inc(currentmove);
 until she;

 end;

procedure balbuk;
 var i,j,k : integer;
 begin
 for k := 1 to 100 do
  begin
  i := random(wc)+1;
  j := random(wc)+1;
  swfig(wh[i],wh[j]);
  end;
 for k := 1 to 100 do
  begin
  i := random(bc)+1;
  j := random(bc)+1;
  swfig(bl[i],bl[j]);
  end;

 end;

procedure MakeBoardCalculations;
 var i,j,k : integer;
 begin
 for k := 1 to 3 do
 for i := 1 to 8 do
  for j := 1 to 8 do rb[k,i,j]:=round((1.25-sqrt(sqr(i-4.5)+sqr(j-4.5))/20)*figv[k]);
 for k := 4 to 6 do
  for i := 1 to 8 do
   for j := 1 to 8 do rb[k,j,i]:=figv[k];
 end;
 
function  MouseInitR : boolean;
 var r : longint;
 begin
 r := mouse_init('/dev/gpmdata',MOUSE_GPM, 1200);
 if r = 0 then
    begin
    mouse_setxrange(0,639);
    mouse_setyrange(0,479);
    mouse_setscale(16);
    end;
 MouseInitR := (r = 0);
 end; 

BEGIN
if not MouseInitR then
    begin
    Writeln('Could Not find mouse!!! Falling back to emulation');
    mouseemu := true;
    end;
mouse_setxrange(0,639);
mouse_setyrange(0,479);
randomize;
MakeBoardCalculations;
graphinit;
ReadSave('zchess.in');
balbuk;
game;
closegraph;
mouse_close;

END.
